package nocturne.jfly;


import java.text.MessageFormat;

/**
 *   A0
 */
public class Automata
{
    //  
    private IFly _fly;

    //   
    private IRandomGenerator _randomGenerator;

    //  
    private ITickCounter _tickCounter;

    // 
    public Automata(IFly _fly, IRandomGenerator _randomGenerator, ITickCounter _tickCounter)
    {
        this._fly = _fly;
        this._randomGenerator = _randomGenerator;
        this._tickCounter = _tickCounter;
    }

    //   A0
    private int _y0;

    public int get_y0()
    {
        return _y0;
    }

    //   A0
    public void A0(int e)
    {
        LoggingEnvironment.getInstance().get_log().log("A0", MessageFormat.format("   {0}   {1}", new Object[] {new Integer(e), new Integer(_y0)}), IFlyLog.OPEN_SCOPE);

        //   
        int oldy0 = _y0;

        switch (_y0)
        {
            case 0:
                if ((e == 1) && x14())
                {
                    z29();
                    _y0 = 4;
                }
                else if ((e == 1) && x12())
                {
                    z22();
                    _y0 = 2;
                }
                else if ((e == 1) && x11() && x17())
                {
                    z21();
                    _y0 = 1;
                }
                else if ((e == 1) && x13() && x18())
                {
                    z23();
                    z28();
                    _y0 = 3;
                }
                else if (e == 1)
                {
                    z22();
                    z28();
                    _y0 = 3;
                }
                break;
            case 1:
                if ((e == 1) && x16())
                {
                    _y0 = 0;
                }
                else if (e == 1)
                {
                    z25();
                    z24();
                    _y0 = 1;
                }
                break;
            case 2:
                if ((e == 1) && x16())
                {
                    _y0 = 0;
                }
                else if (e == 1)
                {
                    z26();
                    z24();
                    _y0 = 2;
                }
                break;
            case 3:
                if ((e == 1) && x16())
                {
                    _y0 = 0;
                }
                else if (e == 1)
                {
                    z27();
                    z24();
                    _y0 = 3;
                }
                break;
            case 4:
                if ((e == 1) && x15())
                {
                    _y0 = 0;
                }
                else if (e == 1)
                {
                    z30();
                    _y0 = 4;
                }
        }

        if (_y0 != oldy0)
        {
            LoggingEnvironment.getInstance().get_log().log("A0", MessageFormat.format("    {0}", new Object[] {new Integer(_y0)}), IFlyLog.NOTIFICATION);

            switch (_y0)
            {
                case 1:
                    z25();
                    z24();
                    break;
                case 2:
                    z26();
                    z24();
                    break;
                case 3:
                    z27();
                    z24();
                    break;
            }
        }

        LoggingEnvironment.getInstance().get_log().log("A0", MessageFormat.format("  {0} ", new Object[] {new Integer(e)}), IFlyLog.CLOSE_SCOPE);
    }

    /**
     *     25
     */
    private boolean x11()
    {
        boolean result = _fly.getDistance() > 25;

        LoggingEnvironment.getInstance().get_log().log("A0", MessageFormat.format("x11 (    25) =  {0}", new Object[] {new Boolean(result)}), IFlyLog.NOTIFICATION);

        return result;
    }

    /**
     *     10
     */
    private boolean x12()
    {
        boolean result = _fly.getDistance() < 10;

        LoggingEnvironment.getInstance().get_log().log("A0", MessageFormat.format("x12 (    10) =  {0}", new Object[] {new Boolean(result)}), IFlyLog.NOTIFICATION);

        return result;
    }

    /**
     *     30
     */
    private boolean x13()
    {
        boolean result = _fly.getDistance() > 30;

        LoggingEnvironment.getInstance().get_log().log("Fly", MessageFormat.format("happenedOneThirdRandom (    30) =  {0}", new Object[] {new Boolean(result)}), IFlyLog.NOTIFICATION);

        return result;
    }

    /**
     *     5   15
     */
    private boolean x14()
    {
        boolean result = _fly.getDistance() > 5 && _fly.getDistance() < 15;

        LoggingEnvironment.getInstance().get_log().log("A0", MessageFormat.format("x14 (    5   15) =  {0}", new Object[] {new Boolean(result)}), IFlyLog.NOTIFICATION);

        return result;
    }

    /**
     *   
     */
    private boolean x15()
    {
        return _fly.isCurrentPatternFinished();
    }

    /**
     *  ,    , 
     */
    private boolean x16()
    {
        return _tickCounter.isTicksExpired();
    }

    /**
     *      1/3
     */
    private boolean x17()
    {
        return _randomGenerator.happenedOneThirdRandom();
    }

    /**
     *      1/2
     */
    private boolean x18()
    {
        return _randomGenerator.happenedOneHalfRandom();
    }

    /**
     *        15
     */
    private void z21()
    {
        LoggingEnvironment.getInstance().get_log().log("A0", "z21:        15", IFlyLog.NOTIFICATION);

        _tickCounter.setTicksCount(15);
    }

    /**
     *        20
     */
    private void z22()
    {
        LoggingEnvironment.getInstance().get_log().log("A0", "z22:        20", IFlyLog.NOTIFICATION);

        _tickCounter.setTicksCount(20);
    }

    /**
     *        5
     */
    private void z23()
    {
        LoggingEnvironment.getInstance().get_log().log("A0", "z23:        5", IFlyLog.NOTIFICATION);

        _tickCounter.setTicksCount(5);
    }

    /**
     *     1
     */
    private void z24()
    {
        _tickCounter.decreaseTicksCount();
    }

    /**
     *   .
     */
    private void z25()
    {
        _fly.moveToPlayer();
    }

    /**
     *   
     */
    private void z26()
    {
        _fly.moveFromPlayer();
    }

    /**
     *   ,   
     */
    private void z27()
    {
        _fly.moveByDirectionVector();
    }

    /**
     *   .
     */
    private void z28()
    {
        _fly.setRandomDirection();
    }

    /**
     *   
     */
    private void z29()
    {
        _fly.setRandomPattern();
    }

    /**
     *     
     */
    private void z30()
    {
        _fly.goToNextPatternPosition();
    }
}
