package nocturne.jfly;



/**
 *  
 */
public class VectorPattern implements IPattern
{
    //  
    private int[] _xs;
    private int[] _ys;

    //   
    private int _currentIndex = 0;

    public VectorPattern(int[] xs, int[] ys) throws IllegalArgumentException
    {
        if (xs.length != ys.length)
            throw new IllegalArgumentException("    ");

        this._xs = xs;
        this._ys = ys;
    }

    /**
     *  
     */
    public void start()
    {
        _currentIndex = 0;
    }

    /**
     *    
     */
    public void next()
    {
        if (_currentIndex < _xs.length - 1)
            _currentIndex++;
    }

    /**
     *  
     */
    public boolean isFinished()
    {
        return _currentIndex == _xs.length - 1;
    }

    /**
     *  x-  
     */
    public int get_x()
    {
        return _xs[_currentIndex];
    }

    /**
     *  y-  
     */
    public int get_y()
    {
        return _ys[_currentIndex];
    }
}